#!/bin/sh

curr_user=`whoami`
dirty_check="dirty"
pokefile="pokeball"
workdir=`readlink -f $0`
dirtydir=`dirname $workdir`
poke_dirty=$1

testuser="dirtycow"`date "+%M%N"`
homedir="/home/${testuser}"

ARCH=`file /bin/ls | awk '{print $3}'`

echo "DirtyCow check and fix needs quite some time, please be patient."
echo

trap '$dirtydir/clean.sh $dirty_check ${testuser}; exit' 1 2

if [ "$curr_user"x != "root"x ];then
	echo "You are not root, please use root to run this script!"
    exit 1
fi

if [ "$ARCH"x = "32-bit"x ]
then
    dirty_check="dirty32"
else
    dirty_check="dirty64"
fi

useradd -r -m -s /bin/bash ${testuser}

cp $dirtydir/$dirty_check ${homedir}/$dirty_check
cp $dirtydir/$pokefile ${homedir}/$pokefile
cp $dirtydir/run_dirtycow.sh ${homedir}

chown -R ${testuser}:${testuser} ${homedir}

su - ${testuser} -c "sh run_dirtycow.sh ./$dirty_check $pokefile"

cp -f ${homedir}/$pokefile $1

userdel -rf ${testuser} 2>/dev/null 1>/dev/null
