#!/bin/bash

apt-get update --fix-missing

latest_kernel=""
OLD_IFS=${IFS}
IFS=$'\n'
#old_kernel_version=`ls /boot/vmlinuz-*  | sed 's/\/boot\/vmlinuz/linux-image/g'`
old_kernel_version=`dpkg -S linux-image- 2>&1 | grep linux-image-[0-9].*-generic: | awk -F: '{print $1}' | sort | uniq`
old_kernel_arr=($old_kernel_version)

apt-get install -y linux-image-generic
#all_kernel_version=`ls /boot/vmlinuz-*  | sed 's/\/boot\/vmlinuz/linux-image/g'`
all_kernel_version=`dpkg -S linux-image- 2>&1 | grep linux-image-[0-9].*-generic: | awk -F: '{print $1}' | sort | uniq`
all_kernel_arr=($all_kernel_version)

# find the latest kernel
for new_kernel in ${all_kernel_arr[@]};do
    found="false"
    for old_kernel in ${old_kernel_arr[@]}; do
        if [ "${new_kernel}x" == "${old_kernel}x" ];then
            found="true"
            break
        fi
    done
    if [ ${found} = "false" ];then
        latest_kernel=${new_kernel}
        break
    fi
done

# the latest kernel version already install
if [ "${latest_kernel}x" = "x" ]; then
    IFS=${OLD_IFS}
    echo "You have installed the latest kernel already, but your current kernel is not the latest one!"
    echo "Please ensure the first boot kernel is the latest kernel in grub.cfg and reboot system"
    exit 1
fi

echo "=== The latest kernel version is ${latest_kernel} ==="

# delete all the old kernels
delete_flag="false"
while [ 1 -eq 1 ]; do
    #kernel_version=`ls /boot/vmlinuz-*  | sed 's/\/boot\/vmlinuz/linux-image/g'`
    kernel_version=`dpkg -S linux-image- 2>&1 | grep linux-image-[0-9].*-generic: | awk -F: '{print $1}' | sort | uniq`
    kernel_arr=($kernel_version)
    for kernel in ${kernel_arr[@]};do
        if [ ${kernel} != ${latest_kernel} ]; then
            apt-get remove -y ${kernel}
            delete_flag="true"
        fi
    done
    if [ ${delete_flag} = "false" ]; then
        break
    fi
    delete_flag="false"
done

# ensure there is at least one kernel
kernel_version=`ls /boot/vmlinuz-*`
if [ "${kernel_version}x" = "x" ];then
    apt-get install -y linux-image-generic
fi
IFS=${OLD_IFS}
